// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package database

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/devops/devops_models"
)

// GetDatabasesObservableReader is a Reader for the GetDatabasesObservable structure.
type GetDatabasesObservableReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDatabasesObservableReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDatabasesObservableOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetDatabasesObservableUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetDatabasesObservableForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetDatabasesObservableNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetDatabasesObservableUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetDatabasesObservableInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetDatabasesObservableOK creates a GetDatabasesObservableOK with default headers values
func NewGetDatabasesObservableOK() *GetDatabasesObservableOK {
	return &GetDatabasesObservableOK{}
}

/*
GetDatabasesObservableOK describes a response with status code 200, with default header values.

Single Database record response
*/
type GetDatabasesObservableOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload []*devops_models.Database
}

// IsSuccess returns true when this get databases observable o k response has a 2xx status code
func (o *GetDatabasesObservableOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get databases observable o k response has a 3xx status code
func (o *GetDatabasesObservableOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get databases observable o k response has a 4xx status code
func (o *GetDatabasesObservableOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get databases observable o k response has a 5xx status code
func (o *GetDatabasesObservableOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get databases observable o k response a status code equal to that given
func (o *GetDatabasesObservableOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get databases observable o k response
func (o *GetDatabasesObservableOK) Code() int {
	return 200
}

func (o *GetDatabasesObservableOK) Error() string {
	return fmt.Sprintf("[GET /databases/observable][%d] getDatabasesObservableOK  %+v", 200, o.Payload)
}

func (o *GetDatabasesObservableOK) String() string {
	return fmt.Sprintf("[GET /databases/observable][%d] getDatabasesObservableOK  %+v", 200, o.Payload)
}

func (o *GetDatabasesObservableOK) GetPayload() []*devops_models.Database {
	return o.Payload
}

func (o *GetDatabasesObservableOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabasesObservableUnauthorized creates a GetDatabasesObservableUnauthorized with default headers values
func NewGetDatabasesObservableUnauthorized() *GetDatabasesObservableUnauthorized {
	return &GetDatabasesObservableUnauthorized{}
}

/*
GetDatabasesObservableUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetDatabasesObservableUnauthorized struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get databases observable unauthorized response has a 2xx status code
func (o *GetDatabasesObservableUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get databases observable unauthorized response has a 3xx status code
func (o *GetDatabasesObservableUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get databases observable unauthorized response has a 4xx status code
func (o *GetDatabasesObservableUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this get databases observable unauthorized response has a 5xx status code
func (o *GetDatabasesObservableUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this get databases observable unauthorized response a status code equal to that given
func (o *GetDatabasesObservableUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the get databases observable unauthorized response
func (o *GetDatabasesObservableUnauthorized) Code() int {
	return 401
}

func (o *GetDatabasesObservableUnauthorized) Error() string {
	return fmt.Sprintf("[GET /databases/observable][%d] getDatabasesObservableUnauthorized  %+v", 401, o.Payload)
}

func (o *GetDatabasesObservableUnauthorized) String() string {
	return fmt.Sprintf("[GET /databases/observable][%d] getDatabasesObservableUnauthorized  %+v", 401, o.Payload)
}

func (o *GetDatabasesObservableUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetDatabasesObservableUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabasesObservableForbidden creates a GetDatabasesObservableForbidden with default headers values
func NewGetDatabasesObservableForbidden() *GetDatabasesObservableForbidden {
	return &GetDatabasesObservableForbidden{}
}

/*
GetDatabasesObservableForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetDatabasesObservableForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get databases observable forbidden response has a 2xx status code
func (o *GetDatabasesObservableForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get databases observable forbidden response has a 3xx status code
func (o *GetDatabasesObservableForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get databases observable forbidden response has a 4xx status code
func (o *GetDatabasesObservableForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this get databases observable forbidden response has a 5xx status code
func (o *GetDatabasesObservableForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this get databases observable forbidden response a status code equal to that given
func (o *GetDatabasesObservableForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the get databases observable forbidden response
func (o *GetDatabasesObservableForbidden) Code() int {
	return 403
}

func (o *GetDatabasesObservableForbidden) Error() string {
	return fmt.Sprintf("[GET /databases/observable][%d] getDatabasesObservableForbidden  %+v", 403, o.Payload)
}

func (o *GetDatabasesObservableForbidden) String() string {
	return fmt.Sprintf("[GET /databases/observable][%d] getDatabasesObservableForbidden  %+v", 403, o.Payload)
}

func (o *GetDatabasesObservableForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetDatabasesObservableForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabasesObservableNotFound creates a GetDatabasesObservableNotFound with default headers values
func NewGetDatabasesObservableNotFound() *GetDatabasesObservableNotFound {
	return &GetDatabasesObservableNotFound{}
}

/*
GetDatabasesObservableNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetDatabasesObservableNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get databases observable not found response has a 2xx status code
func (o *GetDatabasesObservableNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get databases observable not found response has a 3xx status code
func (o *GetDatabasesObservableNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get databases observable not found response has a 4xx status code
func (o *GetDatabasesObservableNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get databases observable not found response has a 5xx status code
func (o *GetDatabasesObservableNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get databases observable not found response a status code equal to that given
func (o *GetDatabasesObservableNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the get databases observable not found response
func (o *GetDatabasesObservableNotFound) Code() int {
	return 404
}

func (o *GetDatabasesObservableNotFound) Error() string {
	return fmt.Sprintf("[GET /databases/observable][%d] getDatabasesObservableNotFound  %+v", 404, o.Payload)
}

func (o *GetDatabasesObservableNotFound) String() string {
	return fmt.Sprintf("[GET /databases/observable][%d] getDatabasesObservableNotFound  %+v", 404, o.Payload)
}

func (o *GetDatabasesObservableNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetDatabasesObservableNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabasesObservableUnprocessableEntity creates a GetDatabasesObservableUnprocessableEntity with default headers values
func NewGetDatabasesObservableUnprocessableEntity() *GetDatabasesObservableUnprocessableEntity {
	return &GetDatabasesObservableUnprocessableEntity{}
}

/*
GetDatabasesObservableUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetDatabasesObservableUnprocessableEntity struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get databases observable unprocessable entity response has a 2xx status code
func (o *GetDatabasesObservableUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get databases observable unprocessable entity response has a 3xx status code
func (o *GetDatabasesObservableUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get databases observable unprocessable entity response has a 4xx status code
func (o *GetDatabasesObservableUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this get databases observable unprocessable entity response has a 5xx status code
func (o *GetDatabasesObservableUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this get databases observable unprocessable entity response a status code equal to that given
func (o *GetDatabasesObservableUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the get databases observable unprocessable entity response
func (o *GetDatabasesObservableUnprocessableEntity) Code() int {
	return 422
}

func (o *GetDatabasesObservableUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /databases/observable][%d] getDatabasesObservableUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetDatabasesObservableUnprocessableEntity) String() string {
	return fmt.Sprintf("[GET /databases/observable][%d] getDatabasesObservableUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetDatabasesObservableUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetDatabasesObservableUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabasesObservableInternalServerError creates a GetDatabasesObservableInternalServerError with default headers values
func NewGetDatabasesObservableInternalServerError() *GetDatabasesObservableInternalServerError {
	return &GetDatabasesObservableInternalServerError{}
}

/*
GetDatabasesObservableInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetDatabasesObservableInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get databases observable internal server error response has a 2xx status code
func (o *GetDatabasesObservableInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get databases observable internal server error response has a 3xx status code
func (o *GetDatabasesObservableInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get databases observable internal server error response has a 4xx status code
func (o *GetDatabasesObservableInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this get databases observable internal server error response has a 5xx status code
func (o *GetDatabasesObservableInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this get databases observable internal server error response a status code equal to that given
func (o *GetDatabasesObservableInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the get databases observable internal server error response
func (o *GetDatabasesObservableInternalServerError) Code() int {
	return 500
}

func (o *GetDatabasesObservableInternalServerError) Error() string {
	return fmt.Sprintf("[GET /databases/observable][%d] getDatabasesObservableInternalServerError  %+v", 500, o.Payload)
}

func (o *GetDatabasesObservableInternalServerError) String() string {
	return fmt.Sprintf("[GET /databases/observable][%d] getDatabasesObservableInternalServerError  %+v", 500, o.Payload)
}

func (o *GetDatabasesObservableInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetDatabasesObservableInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
