// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tenant

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/devops/devops_models"
)

// GetTenantsObservableReader is a Reader for the GetTenantsObservable structure.
type GetTenantsObservableReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetTenantsObservableReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetTenantsObservableOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetTenantsObservableUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetTenantsObservableForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetTenantsObservableNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetTenantsObservableUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetTenantsObservableInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetTenantsObservableOK creates a GetTenantsObservableOK with default headers values
func NewGetTenantsObservableOK() *GetTenantsObservableOK {
	return &GetTenantsObservableOK{}
}

/*
GetTenantsObservableOK describes a response with status code 200, with default header values.

Single Tenant record response
*/
type GetTenantsObservableOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload []*devops_models.Tenant
}

// IsSuccess returns true when this get tenants observable o k response has a 2xx status code
func (o *GetTenantsObservableOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get tenants observable o k response has a 3xx status code
func (o *GetTenantsObservableOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get tenants observable o k response has a 4xx status code
func (o *GetTenantsObservableOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get tenants observable o k response has a 5xx status code
func (o *GetTenantsObservableOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get tenants observable o k response a status code equal to that given
func (o *GetTenantsObservableOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get tenants observable o k response
func (o *GetTenantsObservableOK) Code() int {
	return 200
}

func (o *GetTenantsObservableOK) Error() string {
	return fmt.Sprintf("[GET /tenants/observable][%d] getTenantsObservableOK  %+v", 200, o.Payload)
}

func (o *GetTenantsObservableOK) String() string {
	return fmt.Sprintf("[GET /tenants/observable][%d] getTenantsObservableOK  %+v", 200, o.Payload)
}

func (o *GetTenantsObservableOK) GetPayload() []*devops_models.Tenant {
	return o.Payload
}

func (o *GetTenantsObservableOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantsObservableUnauthorized creates a GetTenantsObservableUnauthorized with default headers values
func NewGetTenantsObservableUnauthorized() *GetTenantsObservableUnauthorized {
	return &GetTenantsObservableUnauthorized{}
}

/*
GetTenantsObservableUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetTenantsObservableUnauthorized struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get tenants observable unauthorized response has a 2xx status code
func (o *GetTenantsObservableUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get tenants observable unauthorized response has a 3xx status code
func (o *GetTenantsObservableUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get tenants observable unauthorized response has a 4xx status code
func (o *GetTenantsObservableUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this get tenants observable unauthorized response has a 5xx status code
func (o *GetTenantsObservableUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this get tenants observable unauthorized response a status code equal to that given
func (o *GetTenantsObservableUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the get tenants observable unauthorized response
func (o *GetTenantsObservableUnauthorized) Code() int {
	return 401
}

func (o *GetTenantsObservableUnauthorized) Error() string {
	return fmt.Sprintf("[GET /tenants/observable][%d] getTenantsObservableUnauthorized  %+v", 401, o.Payload)
}

func (o *GetTenantsObservableUnauthorized) String() string {
	return fmt.Sprintf("[GET /tenants/observable][%d] getTenantsObservableUnauthorized  %+v", 401, o.Payload)
}

func (o *GetTenantsObservableUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTenantsObservableUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantsObservableForbidden creates a GetTenantsObservableForbidden with default headers values
func NewGetTenantsObservableForbidden() *GetTenantsObservableForbidden {
	return &GetTenantsObservableForbidden{}
}

/*
GetTenantsObservableForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetTenantsObservableForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get tenants observable forbidden response has a 2xx status code
func (o *GetTenantsObservableForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get tenants observable forbidden response has a 3xx status code
func (o *GetTenantsObservableForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get tenants observable forbidden response has a 4xx status code
func (o *GetTenantsObservableForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this get tenants observable forbidden response has a 5xx status code
func (o *GetTenantsObservableForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this get tenants observable forbidden response a status code equal to that given
func (o *GetTenantsObservableForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the get tenants observable forbidden response
func (o *GetTenantsObservableForbidden) Code() int {
	return 403
}

func (o *GetTenantsObservableForbidden) Error() string {
	return fmt.Sprintf("[GET /tenants/observable][%d] getTenantsObservableForbidden  %+v", 403, o.Payload)
}

func (o *GetTenantsObservableForbidden) String() string {
	return fmt.Sprintf("[GET /tenants/observable][%d] getTenantsObservableForbidden  %+v", 403, o.Payload)
}

func (o *GetTenantsObservableForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTenantsObservableForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantsObservableNotFound creates a GetTenantsObservableNotFound with default headers values
func NewGetTenantsObservableNotFound() *GetTenantsObservableNotFound {
	return &GetTenantsObservableNotFound{}
}

/*
GetTenantsObservableNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetTenantsObservableNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get tenants observable not found response has a 2xx status code
func (o *GetTenantsObservableNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get tenants observable not found response has a 3xx status code
func (o *GetTenantsObservableNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get tenants observable not found response has a 4xx status code
func (o *GetTenantsObservableNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get tenants observable not found response has a 5xx status code
func (o *GetTenantsObservableNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get tenants observable not found response a status code equal to that given
func (o *GetTenantsObservableNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the get tenants observable not found response
func (o *GetTenantsObservableNotFound) Code() int {
	return 404
}

func (o *GetTenantsObservableNotFound) Error() string {
	return fmt.Sprintf("[GET /tenants/observable][%d] getTenantsObservableNotFound  %+v", 404, o.Payload)
}

func (o *GetTenantsObservableNotFound) String() string {
	return fmt.Sprintf("[GET /tenants/observable][%d] getTenantsObservableNotFound  %+v", 404, o.Payload)
}

func (o *GetTenantsObservableNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTenantsObservableNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantsObservableUnprocessableEntity creates a GetTenantsObservableUnprocessableEntity with default headers values
func NewGetTenantsObservableUnprocessableEntity() *GetTenantsObservableUnprocessableEntity {
	return &GetTenantsObservableUnprocessableEntity{}
}

/*
GetTenantsObservableUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetTenantsObservableUnprocessableEntity struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get tenants observable unprocessable entity response has a 2xx status code
func (o *GetTenantsObservableUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get tenants observable unprocessable entity response has a 3xx status code
func (o *GetTenantsObservableUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get tenants observable unprocessable entity response has a 4xx status code
func (o *GetTenantsObservableUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this get tenants observable unprocessable entity response has a 5xx status code
func (o *GetTenantsObservableUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this get tenants observable unprocessable entity response a status code equal to that given
func (o *GetTenantsObservableUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the get tenants observable unprocessable entity response
func (o *GetTenantsObservableUnprocessableEntity) Code() int {
	return 422
}

func (o *GetTenantsObservableUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /tenants/observable][%d] getTenantsObservableUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetTenantsObservableUnprocessableEntity) String() string {
	return fmt.Sprintf("[GET /tenants/observable][%d] getTenantsObservableUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetTenantsObservableUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTenantsObservableUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTenantsObservableInternalServerError creates a GetTenantsObservableInternalServerError with default headers values
func NewGetTenantsObservableInternalServerError() *GetTenantsObservableInternalServerError {
	return &GetTenantsObservableInternalServerError{}
}

/*
GetTenantsObservableInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetTenantsObservableInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get tenants observable internal server error response has a 2xx status code
func (o *GetTenantsObservableInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get tenants observable internal server error response has a 3xx status code
func (o *GetTenantsObservableInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get tenants observable internal server error response has a 4xx status code
func (o *GetTenantsObservableInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this get tenants observable internal server error response has a 5xx status code
func (o *GetTenantsObservableInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this get tenants observable internal server error response a status code equal to that given
func (o *GetTenantsObservableInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the get tenants observable internal server error response
func (o *GetTenantsObservableInternalServerError) Code() int {
	return 500
}

func (o *GetTenantsObservableInternalServerError) Error() string {
	return fmt.Sprintf("[GET /tenants/observable][%d] getTenantsObservableInternalServerError  %+v", 500, o.Payload)
}

func (o *GetTenantsObservableInternalServerError) String() string {
	return fmt.Sprintf("[GET /tenants/observable][%d] getTenantsObservableInternalServerError  %+v", 500, o.Payload)
}

func (o *GetTenantsObservableInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTenantsObservableInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
