// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/members/members_models"
)

// NewCreateOrderParams creates a new CreateOrderParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateOrderParams() *CreateOrderParams {
	return &CreateOrderParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateOrderParamsWithTimeout creates a new CreateOrderParams object
// with the ability to set a timeout on a request.
func NewCreateOrderParamsWithTimeout(timeout time.Duration) *CreateOrderParams {
	return &CreateOrderParams{
		timeout: timeout,
	}
}

// NewCreateOrderParamsWithContext creates a new CreateOrderParams object
// with the ability to set a context for a request.
func NewCreateOrderParamsWithContext(ctx context.Context) *CreateOrderParams {
	return &CreateOrderParams{
		Context: ctx,
	}
}

// NewCreateOrderParamsWithHTTPClient creates a new CreateOrderParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateOrderParamsWithHTTPClient(client *http.Client) *CreateOrderParams {
	return &CreateOrderParams{
		HTTPClient: client,
	}
}

/*
CreateOrderParams contains all the parameters to send to the API endpoint

	for the create order operation.

	Typically these are written to a http.Request.
*/
type CreateOrderParams struct {

	/* OrderRequest.

	   An array of new Order records
	*/
	OrderRequest *members_models.OrderRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create order params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateOrderParams) WithDefaults() *CreateOrderParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create order params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateOrderParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create order params
func (o *CreateOrderParams) WithTimeout(timeout time.Duration) *CreateOrderParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create order params
func (o *CreateOrderParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create order params
func (o *CreateOrderParams) WithContext(ctx context.Context) *CreateOrderParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create order params
func (o *CreateOrderParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create order params
func (o *CreateOrderParams) WithHTTPClient(client *http.Client) *CreateOrderParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create order params
func (o *CreateOrderParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOrderRequest adds the orderRequest to the create order params
func (o *CreateOrderParams) WithOrderRequest(orderRequest *members_models.OrderRequest) *CreateOrderParams {
	o.SetOrderRequest(orderRequest)
	return o
}

// SetOrderRequest adds the orderRequest to the create order params
func (o *CreateOrderParams) SetOrderRequest(orderRequest *members_models.OrderRequest) {
	o.OrderRequest = orderRequest
}

// WriteToRequest writes these params to a swagger request
func (o *CreateOrderParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.OrderRequest != nil {
		if err := r.SetBodyParam(o.OrderRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
